;Short: FKILETATRIZ
;Description: classic tetris game - 1024 bytes code
;Platform: ZX Spectrum - only 48k mode !
;Author: POXOFT/uZeroNiq 2011

                org 39920

                ret
semjenejde      pop de
                pop hl
                ld hl,41536
                ld a,(hl)
                inc l
                ld (hl),a
                inc l
                ld a,(hl)
                inc l
                ld (hl),a
                ld a,254
                ret

grafika         org 39936

smile_color1    defb 0,60,90,126,90,102,60,0
smile_color2    defb 60,66,129,129,129,129,66,60
obr1            defb 1,112,98,32,7,64,68,96
obr2            defb 102,0,102,0,102,0,102,0
obr3            defb 2,112,38,32,7,32,70,64
obr4            defb 4,112,34,96,7,16,100,64
obr5            defb 3,96,70,32,3,96,70,32
obr6            defb 15,0,68,68,15,0,68,68
obr7            defb 6,48,38,64,6,48,38,64
obr8            defb 19,96,99,16,54,64,70,48
poxoftdata      defb 64,51,7,5
poxoft1         defb 62,251,255,255,252
poxoft2         defb 54,216,0,0,0
poxoft3         defb 54,219,111,190,96
poxoft4         defb 54,219,109,176,96
poxoft5         defb 62,249,205,188,96
poxoft6         defb 48,3,109,176,96
poxoft7         defb 55,251,111,176,96
barva           defb 88,68
fkiledata       defb 65,149,5,6
fkile1          defb 118,54,119,153,231,111
fkile2          defb 198,134,195,52,203,3
fkile3          defb 231,54,227,60,199,102
fkile4          defb 198,182,195,52,203,108
fkile5          defb 198,182,115,52,203,111
barvafkile      defb 88,71
opqadata        defb 80,148,5,6
opqa1           defb 35,194,60,89,224,143
opqa2           defb 99,67,52,101,128,140
opqa3           defb 251,79,188,117,227,236
opqa4           defb 99,67,48,5,129,204
opqa5           defb 35,194,48,57,224,143
barvaopqa       defb 90,70
scrdata         defb 72,20,5,3
scr1            defb 119,119,112
scr2            defb 68,84,64
scr3            defb 116,84,96
scr4            defb 20,84,64
scr5            defb 119,116,112
scrbarva        defb 89,7
colorsy         defb 80,48,96,24,104,56,32,112,88,120,40


MAIN		org 40161

presuny         ld hl,tisk
                ld de,39833
                ld bc,87
                ldir
                ld hl,39834
                dec (hl)
                ld l,168
		ld (hl),145
                ld l,190
                inc (hl)
                ld l,229
                ld (hl),86
                inc l
                ld (hl),32
                inc l
                ld (hl),9

                ld a,100
                ld hl,39936
duocolor        add a,24
                ld de,49928
colour          push bc
                ld c,8
nextbyte        ld b,8
chkbit          bit 7,(hl)
                jr z,nofull
                ld (de),a
                out (254),a
nofull          rl (hl)
                inc e
                djnz chkbit
                inc l
                dec c
                jr nz,nextbyte
                ld e,c
                inc d
                pop bc
                cp 124
                jr z,duocolor
                cp 148
                jr nz,nicmocne
                ld d,164
                ld a,d
                ld b,9
nicmocne        djnz colour
                push hl
cls             ld hl,23300  ;only 48k mode !!!!!
                ld d,h
                ld b,27
                lddr
pxlogo          ld d,l
                pop hl
loga            push de
gfxnow          ld d,(hl)
                inc l
                ld e,(hl)
                inc l
                ld a,(hl)
                inc l
                ld c,(hl)
                inc l
pxradek         push bc
                push de
                ldir
                pop de
                pop bc
                inc d
                dec a
                jr nz,pxradek
                ld d,(hl)
                inc l
                ld a,(hl)
barevno         ld (de),a
                inc e
                dec c
                jr nz,barevno
                inc l
                pop de
                dec d
                jr nz, loga

                ld a,9
                ld hl,22543
                ld e,l
blue            ld b,a
xxx             ld (hl),76
                inc l
                inc l
                djnz xxx   
                add hl,de
                dec a
                jr nz,blue

gameover        ld b,24
                ld hl,517
                ld d,l
hrajto          push bc
                push hl
                ld e,b
                call 949
                pop hl
                pop bc
                inc h
                inc c
                djnz hrajto

                ld hl,22509
                ld de,20   
fill4           ld b,12
                add hl,de
fill3           ld (hl),e 
                inc l
                djnz fill3
                dec c
                jr nz,fill4
                ld a,36
                ld (scanuj+1),a

delnito         xor a
                call vidim2

                call kontrola

                ld hl, 39936
nuluj2          ld (hl),c
                inc l
                djnz nuluj2
likvidace       call tiskscore
                call vidim

smail           ld hl,49928
                ld e,h
                ld a,l
kluk            ld c,8
                ldir
                ex de,hl
                ld c,24
                add hl,bc
                ex de,hl
                dec a
                jr nz,kluk

vyberobr        ld hl,23204
                ld bc,2
                ld a,148
                cpir
                jr z, nenicelej

speedup         ld hl,scanuj+1
                ld a,(hl)
                sub 4
                ld (hl),a
                ld hl,39940
                inc (hl)
                jr likvidace

nenicelej       ld hl,39936
                ld (hl),l
                ld h,163
                ld d,h
                ld e,l
                ld b,157
nahoda          ld a,(bc)
                and 184
                scf
                jp po,nedavej
                ccf
nedavej         ld a,(bc)
                rla
                ld (bc),a
prictih         inc h
                cp 32
                jr c,jeminnez
                sub 32
                jr prictih
jeminnez        ld a,(de)
                cp h
                jr z,vyberobr
                ld a,h
                ld (de),a
mameho          ld d,181
                ld bc,64
                ldir

rndbarvax       ld hl,40149
                ld a,(hl)
                cp 12
                jr nz,jetodobrx
                xor a
jetodobrx       inc a
                ld (hl),a
                add a,l
                ld l,a
                ld c,(hl)
                ld l,b
                ld h,d
kostickax       ld a,(hl)
                cp b
                jr z,prazdnyx
                ld (hl),c
prazdnyx        inc l
                dec e
                jr nz, kostickax

dalsicube       xor a
                ld b,5
                ld h,162
                ld (hl),a
                inc l
                ld (hl),a
                inc l
                ld (hl),b
                inc l
                ld (hl),b
                inc h
                ld (hl),a
                ld (39875),a
                ld (39839),a
                ld (aktok+1),a
                ld (akt4+1),a

over            call 39869
                cp 254
                jp z,gameover
                call tisk

scanuj          ld b,36

dokola          ld hl,41539
                djnz pokrakuj
                ld a,255
                jr dolu

pokrakuj        push bc
                ld a,(23556)
                cp 80
                jr z,vpravo
                cp 79
                jr z,vlevo
                cp l
                jr z,dolu
                cp 69
                jr z,otocka
semhopni        halt
                pop bc
                jr dokola

dolu            inc l
                ld (hl),a
comdolu         ld hl,41537
                inc (hl)
com1            call 39869
                cp 254
                jr nz,com2
                call umisti
                jp vyberobr
com2            call 39833
                call tisk
                ld a,(41537)
                ld (41536),a
                ld a,(41540)
                cp 67
                jr nz,scanuj
                ld h,c
                call pipak
                jr comdolu

nelzetocit      pop af
                pop hl
                ld a,(hl) 
                ld (39875),a
                jr cekani

vpravo          inc (hl)
                inc (hl)
vlevo           dec (hl)
dotoho          call 39869
suptam          call 39833
                call tisk
                ld hl,41539
                ld a,(hl)
                dec l
                ld (hl),a

cekani          pop bc
                dec b
                ld a,b
                cp 0
                jr nz,takneninula
                inc b
takneninula     push bc
                ld b,10
cekani2         halt
                djnz cekani2
xcross          jr semhopni

otocka          inc h
                ld a,(hl)
                push hl
                inc l
                ld (hl),a
                add a,16
                cp 64
                jr nz,neni64
                xor a
neni64          ld (hl),a
                ld (39875),a
                push af
                call 39869
                cp 254
                jr z,nelzetocit
                call 39833
                pop af
                ld (39839),a
                ld (aktok+1),a
                ld (akt4+1),a
                pop hl
                ld (hl),a
                call tisk
                ld h,a
                call pipak 
                jr xcross

new_xy          ld b,162
		ld hl,22528
                ld a,(bc)
                cp l
                jr z,zaciname
                ld de,32 
semka           add hl,de
                dec a
                jr nz,semka
zaciname        inc c
                inc c
                ld a,(bc)
                add a,l
                ld l,a
                ex de,hl
                ret

tisk            ld c,65
                call new_xy
aktok           ld hl,46336
                ld a,4
tisk_x          push af
                ld b,4
tisk_y          ld a,(de)
                ld c,(hl)
operace         add a,c
                ld (de),a
                inc e
                inc l
                djnz tisk_y
                ld c,28
                ex de,hl
                add hl,bc
                ex de,hl
                pop af
                dec a
                jr nz,tisk_x
                ret

umisti          ld b,20
cokej45         halt
                djnz cokej45

                ld c,64
                call new_xy
akt4            ld hl,46336
                ld c,4
rada_s          ld b,4
sloup_s         ld a,(hl)
                cp 0
                jr z,jetonulas
porovn_s        push hl
                push de
                ex de,hl
                ld a,4
                sub c
                cp 0
                jr z,nepricitas
                ld de,32
plusy_s         add hl,de
                dec a
                jr nz,plusy_s
nepricitas      ld a,4
                sub b
                add a,l
                ld l,a
                set 2,(hl)
                nop
                nop
                pop de
                pop hl
jetonulas       inc l
                djnz sloup_s
                dec c
                jr nz,rada_s

kontrola        ld c,21
                ld de,32
                ld hl,22594
kontloop        push hl
                ld b,10
kont2           ld a,(hl)
                cp d
                jr z,noplny
                inc l
                djnz kont2

smazat          pop hl
                push hl
vymazani        ld b,10
                ld c,b
vymazrad        ld (hl),d
                inc l
                djnz vymazrad

                call score

aznova          pop hl
                ld d,h
                ld e,l
                ld c,32
                sbc hl,bc
                ld a,h
                cp 86
                jr z,kontrola
                ld c,10
                push hl
                ldir
                jr aznova

noplny          pop hl
                add hl,de
                dec c
                jr nz,kontloop
                ret

score           ld hl, 39936
                ld a,(hl)
                cp b
                jr z,ode
                add a,a
                jr ode2
ode             inc a
ode2            ld (hl),a
                inc l
                ld e,(hl)
                add a,e
                cp c
                jr c,minnezdeset
                sub c
                inc l
                inc (hl)
                dec l
minnezdeset     ld (hl),a
                inc l
scoreloop       ld a,(hl)
                cp c
                jr c,tiskscore
                ld (hl),b
                inc l
                inc (hl)
                jr scoreloop

tiskscore       ld l,b
                ld c,5
kompl           inc l
                ld de,15744
                ld a,(hl)
                cp b
                jr z,nulavole
                ld b,a
pridej_e        add a,7
                djnz pridej_e
                add a,e
                ld e,a
nulavole        push hl
                ld h,72
                ld a,115
		add a,c
                ld l,a
                ld b,8
cifra           ld a,(de)
                ld (hl),a
                inc h
                inc e
                djnz cifra
                pop hl
                dec c
                jr nz,kompl

pipak           ld c, h
zvukloop        xor a
                set 4,a
                out (254),a
                ld b, (hl)
zv1             djnz zv1
                res 4,a
                out (254),a
                ld b, c
zv2             djnz zv2
                inc l
                dec c
                jr nz,zvukloop
                ret

vidim           ld a,7
vidim2          ld b,7   
                ld de,22900
radecek         ld (de),a
                inc e
                djnz radecek
                ret

;--- end ---